#ifndef LEAVEWIDGET_H
#define LEAVEWIDGET_H

#include <QDialog>
#include <QDesktopWidget>
#include <QLabel>
#include <QListWidget>
#include <QPushButton>
#include <QTimer>
#include <QProxyStyle>

class LeaveWidget : public QDialog
{
    Q_OBJECT

public:
    enum Stage{
        Leave,
        Inhibit,
    };


    enum ActionType{
        Logout,
        Hibernate,
        Shutdown,
        Reboot,
        Switchuser,
    };

    Q_ENUM(ActionType);
    Q_ENUM(Stage);

    LeaveWidget(QWidget *parent = 0);
    void setGeometry(int ax, int ay, int aw, int ah);
    void setGeometry(QRect rect);
    void setUserAvater();
    void setFontSize();
    void setAppsNotClose();
    void setBackGround();
    void setConfirmText(ActionType type);
    void showEvent(QShowEvent *);

    ~LeaveWidget();

    bool eventFilter(QObject *target, QEvent *event);

Q_SIGNALS:
    void buttonClick();

public Q_SLOTS:
    void buttonClickEvent();
    void updateWindowApp(WId);
    void deleteItem();
    void showUnCloseedApp();

private:
    QLabel *label_head;
    QLabel *label_username;
    QPushButton *button_confirm;
    QPushButton *button_cancel;

    QLabel *label_p1;
    QLabel *label_p2;
    QListWidget *list_app;
    QPushButton *button_yes;
    QPushButton *button_no;
    QTimer *timer_delete;
    QLabel *label_line[2];

    QList<QPixmap> appIcons;
    QStringList appName;
    QStringList appNameBak;
    QList<WId> currentWIds;

    QLabel *label_bg;
    QWidget *mpShadeWindow;
    QFont ft;
};

#endif // LEAVEWIDGET_H
